---
apiVersion: apps/v1
kind: DaemonSet
metadata:
  name: {{ ingress_nginx_namespace }}-controller
  namespace: {{ ingress_nginx_namespace }}
  labels:
    app.kubernetes.io/name: {{ ingress_nginx_namespace }}
    app.kubernetes.io/part-of: {{ ingress_nginx_namespace }}
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ ingress_nginx_namespace }}
      app.kubernetes.io/part-of: {{ ingress_nginx_namespace }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ ingress_nginx_namespace }}
        app.kubernetes.io/part-of: {{ ingress_nginx_namespace }}
      annotations:
        prometheus.io/port: "{{ ingress_nginx_healthz_port }}"
        prometheus.io/scrape: "true"
    spec:
      serviceAccountName: {{ ingress_nginx_namespace }}
{% if ingress_nginx_host_network %}
      hostNetwork: true
{% endif %}
{% if ingress_nginx_nodeselector %}
      nodeSelector:
        {{ ingress_nginx_nodeselector | to_nice_yaml }}
{%- endif %}
{% if kube_version is version('v1.11.1', '>=') %}
      priorityClassName: {% if ingress_nginx_namespace == 'kube-system' %}system-node-critical{% else %}k8s-cluster-critical{% endif %}{{''}}
{% endif %}
      containers:
        - name: {{ ingress_nginx_namespace }}-controller
          image: {{ ingress_nginx_controller_image_repo }}:{{ ingress_nginx_controller_image_tag }}
          imagePullPolicy: {{ k8s_image_pull_policy }}
          args:
            - /nginx-ingress-controller
            - --default-backend-service=$(POD_NAMESPACE)/default-backend
            - --configmap=$(POD_NAMESPACE)/$(POD_NAMESPACE)
            - --tcp-services-configmap=$(POD_NAMESPACE)/tcp-services
            - --udp-services-configmap=$(POD_NAMESPACE)/udp-services
            - --annotations-prefix=nginx.ingress.kubernetes.io
            - --http-port={{ ingress_nginx_insecure_port }}
            - --https-port={{ ingress_nginx_secure_port }}
            - --status-port={{ ingress_nginx_status_port }}
            - --default-server-port={{ ingress_nginx_default_server_port }}
            - --healthz-port={{ ingress_nginx_healthz_port }}

          securityContext:
            capabilities:
                drop:
                  - ALL
                add:
                  - NET_BIND_SERVICE
            # www-data -> 33
            runAsUser: 33
          env:
            - name: POD_NAME
              valueFrom:
                fieldRef:
                  fieldPath: metadata.name
            - name: POD_NAMESPACE
              valueFrom:
                fieldRef:
                  fieldPath: metadata.namespace
          ports:
            - name: http
              containerPort: {{ ingress_nginx_insecure_port }}
              hostPort: {{ ingress_nginx_insecure_port }}
            - name: https
              containerPort: {{ ingress_nginx_secure_port }}
              hostPort: {{ ingress_nginx_secure_port }}
          livenessProbe:
            failureThreshold: 3
            httpGet:
              path: /healthz
              port: {{ ingress_nginx_healthz_port }}
              scheme: HTTP
            initialDelaySeconds: 10
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
          readinessProbe:
            failureThreshold: 3
            httpGet:
              path: /healthz
              port: {{ ingress_nginx_healthz_port }}
              scheme: HTTP
            periodSeconds: 10
            successThreshold: 1
            timeoutSeconds: 1
